{$A+,B-,D-,E-,F+,G+,I+,L-,N-,P+,Q-,R-,S-,T-,V-,X+,Y-}
unit ClocHeap;
interface

uses Dos, Objects, Views, App, Dialogs,colors;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
const
  hcVideoOptions = 5000;
  hcColorOptions = 5001;
  hcDeskOptions  = 5002;
  hcDateOptions  = 5003;
  hcSeparatorsOptions = 5004;
  DateCentury : boolean = True;

  roHeap  : Boolean = false;
  roClock : Byte    = 3;
  roVideo : Boolean = false; { 25 rows }
  roColor : Word    = 0; { Color }
  roDate  : Word    = 1; { DMY }
  roSep   : Word    = 1; { '.' }
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
type
  PHeapView = ^THeapView;
  THeapView = object(TView)
    FreeMem : LongInt;
    constructor Init(var Bounds: TRect);
    destructor Done; virtual;
    procedure Draw; virtual;
    function GetPalette: PPalette; virtual;
    procedure Update;
  end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
  PClockView = ^TClockView;
  TClockView = object(TView)
    Refresh: Byte;
    LastTime: DateTime;
    TimeStr: string[10];
    DayOfWeek                 : word;
    DateStr                   : string [ 13 ];            { dd-Mmm-yy }
    DayStr                    : string [ 3 ];                   { Ddd }
    constructor Init(var Bounds: TRect);
    procedure Draw; virtual;
    function FormatTimeStr(DT: DateTime): String; virtual;
    function DateToStr(DT: DateTime): String;
    procedure Update; virtual;
  end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure hdDeskView;

procedure AddHeap;
procedure DumpHeap;
procedure UpdateHeap;

procedure AddClock;
procedure DumpClock;
procedure UpdateClock;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
implementation

uses Crt, Drivers, Memory;

const
  ViewHeap : PHeapView = NIL;
  Clock : PClockView = NIL;
  TmpStr : string[8] = '        ';

var
  DeskViewRec : record
    VideoOptions : Word;
    ColorOptions : Word;
    DeskOptions : Word;
    DateOptions : Word;
    SeparatorsOptions : Word;
  end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function MakeDialog : PDialog;
{var
  Dlg : PDialog;
  R : TRect;
  Control : PView;}

begin
{R.Assign(17, 4, 63, 19);
New(Dlg, Init(R, 'Settings'));
Dlg^.Options := Dlg^.Options or ofCenterX or ofCenterY;

R.Assign(3, 3, 20, 5);
Control := New(PRadioButtons, Init(R,
  NewSItem('~2~5 lines',
  NewSItem('~4~3/50 lines', Nil))));
Control^.HelpCtx := hcVideoOptions;
Dlg^.Insert(Control);

  R.Assign(2, 2, 14, 3);
  Dlg^.Insert(New(PLabel, Init(R, '~S~creen size', Control)));

R.Assign(24, 3, 43, 6);
Control := New(PRadioButtons, Init(R,
  NewSItem('~C~olor',
  NewSItem('~B~lack-white',
  NewSItem('~M~onochromatic', Nil)))));
Control^.HelpCtx := hcColorOptions;
Dlg^.Insert(Control);

  R.Assign(23, 2, 37, 3);
  Dlg^.Insert(New(PLabel, Init(R, '~C~olors', Control)));

R.Assign(3, 8, 20, 11);
Control := New(PCheckboxes, Init(R,
  NewSItem('Free ~M~emory',
  NewSItem('~C~lock',
  NewSItem('~D~atum', Nil)))));
Control^.HelpCtx := hcDeskOptions;
Dlg^.Insert(Control);

  R.Assign(2, 7, 10, 8);
  Dlg^.Insert(New(PLabel, Init(R, '~D~esktop', Control)));

R.Assign(24, 8, 34, 11);
Control := New(PRadioButtons, Init(R,
  NewSItem('~M~ounth Day Year',
  NewSItem('~D~ay Mounth Year',
  NewSItem('~Y~ear Mounth Day', Nil)))));
Control^.HelpCtx := hcDateOptions;
Dlg^.Insert(Control);

  R.Assign(23, 7, 42, 8);
  Dlg^.Insert(New(PLabel, Init(R, 'Datum format/separ.', Control)));

R.Assign(34, 8, 43, 11);
Control := New(PRadioButtons, Init(R,
  NewSItem('.',
  NewSItem('/',
  NewSItem('-', Nil)))));
Control^.HelpCtx := hcSeparatorsOptions;
Dlg^.Insert(Control);

R.Assign(7, 12, 17, 14);
Control := New(PButton, Init(R, 'O~k~', cmOK, bfDefault));
Dlg^.Insert(Control);

R.Assign(26, 12, 36, 14);
Control := New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal));
Dlg^.Insert(Control);

Dlg^.SelectNext(False);
MakeDialog := Dlg;}
end;


{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
constructor THeapView.Init(var Bounds: TRect);
begin
  inherited Init(Bounds);
  FreeMem := 0;
  GrowMode := gfGrowAll;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
destructor THeapView.Done;
begin
  inherited Done;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure THeapView.Draw;
{var
  S: string[8];}
begin
{  if roHeap then begin
    FreeMem := MemAvail;
    FormatStr(S, '%8d', FreeMem);
    if FreeMem > 100000 then WriteStr(0, 0, S, 1)
    else if FreeMem > 50000 then  WriteStr(0, 0, S, 2)
 else begin
writeStr(0, 0, S, 3);Sound(300);Delay((50000-MemAvail) div 100);NoSound;end;
  end else begin
    WriteStr(0, 0, TmpStr, 1);
  end;}
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function THeapView.GetPalette: PPalette;
const
  P: String[2] = #2#1;
begin
  GetPalette := @P;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure THeapView.Update;
begin
  if (FreeMem <> MemAvail) then DrawView;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function LeadingZero(w: Word): String;
var s: String;
begin
  Str(w:0, s);
  LeadingZero := Copy('00', 1, 2 - Length(s)) + s;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
constructor TClockView.Init(var Bounds: TRect);
begin
  inherited Init(Bounds);
  FillChar(LastTime, SizeOf(LastTime), #$FF);
  TimeStr := '';
  DayOfWeek := 255;
  DateStr := '';
  DayStr := '';
  Refresh := 1;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure TClockView.Draw;
var
  B: TDrawBuffer;
  C: Byte;
begin
  C := GetColor(2);
  MoveChar(B, ' ', C, Size.X);
  case roClock of
    1 : MoveStr(B, TmpStr + #32 + TimeStr, C);
    2 : MoveStr(B, TmpStr + #32 + DateStr, C);
    3 : MoveStr(B, DateStr + #32 + TimeStr, C);
  end;
  WriteLine(0, 0, Size.X, 1, B);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

procedure TClockView.Update;
var
  NewTime : DateTime;
  Hund : word;
begin
with NewTime do  GetTime(Hour , Min , Sec , hund);
if Abs(NewTime.Sec - LastTime.sec) < Refresh then EXIT;
with NewTime do GetDate(Year, Month, Day, DayOfWeek);
LastTime := NewTime;DateStr := DateToStr(LastTime);
TimeStr := FormatTimeStr(LastTime);
if Odd(LastTime.Sec) then TimeStr[6] := #32;
DrawView;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function TClockView.FormatTimeStr(DT: DateTime): String;
begin
  with DT do
FormatTimeStr := LeadingZero(Hour)+ ':'+ LeadingZero(Min) +
      ' ' + LeadingZero(Sec);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function TClockView.DateToStr(DT: DateTime): String;
const Sep : string[3] = './-';
begin
  with DT do begin
    if DateCentury then
    case roDate of
      0 : DateToStr := LeadingZero(Month) + Sep[roSep] + LeadingZero(Day) +
          Sep[roSep] + LeadingZero(Year);
      1 : DateToStr := LeadingZero(Day) + Sep[roSep] + LeadingZero(Month) +
          Sep[roSep] + LeadingZero(Year);
      2 : DateToStr := LeadingZero(Year) + Sep[roSep] + LeadingZero(Month) +
          Sep[roSep] + LeadingZero(Day);
    end;
  end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure AddHeap;
var
  R: TRect;
begin
  if Application = NIL then EXIT;
  Application^.GetExtent(R);
  R.A.X := R.B.X - 8;
  R.A.Y := R.B.Y - 1;
  ViewHeap := New(PHeapView, Init(R));
  Application^.Insert(ViewHeap);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DumpHeap;
begin
  if ViewHeap = NIL then EXIT;
  ViewHeap^.Owner^.Delete(ViewHeap);
  Dispose(ViewHeap,Done);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure UpdateHeap;
begin
  if ViewHeap = NIL then EXIT;
  ViewHeap^.Update;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{----------------------------------------------------}
{ From SHAZAM II: CLOCK2.INC }
procedure AddClock;
var
  R: TRect;
begin
  if Application = NIL then EXIT;
  Application^.GetExtent(R);
  R.A.X:= R.B.X - 17;
  R.B.Y:= R.A.Y + 1;
  Clock:= New(PClockView ,Init(R));
  Application^.Insert(Clock);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DumpClock;
begin
  if Clock = NIL then EXIT;
  Clock^.Owner^.Delete(Clock);
  Dispose(Clock , Done);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure UpdateClock;
begin
  if Clock = NIL then EXIT;
  Clock^.Update;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure SetDesktop;
begin
  with DeskViewRec do begin
    if roVideo then VideoOptions := 1 else VideoOptions := 0;
    ColorOptions := roColor;
    DeskOptions := 0;
    if roClock > 0 then DeskOptions := DeskOptions or (roClock * 2);
    if roHeap then DeskOptions := DeskOptions or $01;
    DateOptions := roDate;
    SeparatorsOptions := roSep - 1;
  end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure LetHeapClock;
begin
  roHeap := (DeskViewRec.DeskOptions and $1) = 1;
  roClock := (DeskViewRec.DeskOptions and $06) div 2;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure LetColor;
begin
  case roColor of
    0 : AppPalette := apColor;
    1 : AppPalette := apBlackWhite;
    2 : AppPalette := apMonochrome;
  end;
  DoneMemory;
  Application^.Redraw;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure hdDeskView;
begin
  SetDeskTop;
  if Application^.ExecuteDialog(MakeDialog, @DeskViewRec) = cmOK then
    with DeskViewRec do begin
      LetHeapClock;
      if roVideo <> (VideoOptions = 1) then begin
        roVideo := (VideoOptions = 1);
        Application^.SetScreenMode(ScreenMode xor smFont8x8);
        LetColor;
      end;
      if ColorOptions <> roColor then begin
        roColor := ColorOptions;
        LetColor;
      end;
      if roDate <> DateOptions then roDate := DateOptions;
      if roSep <> (SeparatorsOptions + 1) then roSep := SeparatorsOptions + 1;
      UpdateHeap;
      UpdateClock;
    end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
  roVideo := (ScreenMode > 7);  { actual mode }
  roColor := AppPalette;  { actual color palette }
  SetDesktop;
end.
